package JProjects.beans;

import java.awt.*;
import java.awt.event.*;

public class YesNoDlg extends Dialog {
  public YesNoDlg(Frame af,String title, String message,
                     String yes_label, String no_label, String cancel_label)
  {
    super(new Frame(),title,true);
    this.setTitle(title);
    this.setLayout(new BorderLayout());

    this.add("Center", new MLLabel(message, 20, 20));

    ActionListener listener = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        YesNoDlg.this.dispose();   // pop down dialog
        if (listeners != null)        // notify all registered listeners
          listeners.actionPerformed(new ActionEvent(YesNoDlg.this,
                                                    e.getID(),
                                                    e.getActionCommand()));
      }
    };

    Panel buttonbox = new Panel();
    buttonbox.setBackground(Color.white);
    buttonbox.setLayout(new FlowLayout(FlowLayout.CENTER, 25, 15));
    this.add("South", buttonbox);

    // Create each specified button, specifying the action listener
    // and action command for each, and adding them to the buttonbox
    if (yes_label != null) {              // if a label was specified...
      Button yes = new Button(yes_label);     //   create button
      yes.setActionCommand("yes");            //   set action command
      yes.addActionListener(listener);        //   set listener
      buttonbox.add(yes);                     //   add button to the panel
    }
    if (no_label != null) {
      Button no = new Button(no_label);
      no.setActionCommand("no");
      no.addActionListener(listener);
      buttonbox.add(no);
    }
    if (cancel_label != null) {
      Button cancel = new Button(cancel_label);
      cancel.setActionCommand("cancel");
      cancel.addActionListener(listener);
      buttonbox.add(cancel);
    }

    // Finally, set the dialog to its preferred size.
    this.pack();
    Rectangle r=getBounds();
    int x=(800-r.width)/2;
    int y=(600-r.height)/2;
    this.setLocation(x,y);
  }

  /** This field will hold a list of registered ActionListeners, thanks
   *  to the magic of AWTEventMulticaster */
  protected ActionListener listeners = null;

  /** Register an action listener to be notified when a button is pressed
   *  AWTEventMulticaster makes this easy. */
  public void addActionListener(ActionListener l) {
    listeners = AWTEventMulticaster.add(listeners, l);
  }

  /** Remove an action listener from our list of interested listeners */
  public void removeActionListener(ActionListener l) {
    listeners = AWTEventMulticaster.remove(listeners, l);
  }

}
