/*Data Access Library. v. 1.0b.
 *Connection listener interface. 
 *AUTHOR:  Alexander Jaremenko <jarem@isb.gomel.by>
 *RELEASE DATE:  02/01/1999
 */

package JProjects.eab.data;

/**Interface for listeners of connection events.
 *@see ConnectionEvent
 *@see ConnectionSupport
 *@see DatastoreJDBC#addConnectionListener
 *@see DatastoreJDBC#removeConnectionListener
 *@author Alexander Jaremenko  <address><a href="mailto:jarem@isb.gomel.by">&lt jarem@isb.gomel.by &gt</a></address>
 */
public interface ConnectionListener extends ParameterListener {

    public abstract void connected(ConnectionEvent ev);
    public abstract void disconnected(ConnectionEvent ev);
    public abstract void committed(ConnectionEvent ev);
    public abstract void executedSQL(ConnectionEvent ev);
    public abstract void rolledback(ConnectionEvent ev);
    public abstract void cancelled(ConnectionEvent ev);
}
