/*Data Access Library. v. 1.0b.
 *Persistent object event listener interface. 
 *AUTHOR:  Alexander Jaremenko <jarem@isb.gomel.by>
 *RELEASE DATE:  02/01/1999
 */

package JProjects.eab.data;

/**Interface for persistent object event listeners. Used in asynchronous model of
 *data access.
 *@see POCompleteEvent
 *@see PersistentObject#addPOCompleteListener
 *@see PersistentObject#removePOCompleteListener
 *@author Alexander Jaremenko  <address><a href="mailto:jarem@isb.gomel.by">&lt jarem@isb.gomel.by &gt</a></address>
*/
public interface POCompleteListener extends ParameterListener {

    public abstract void updateComplete(POCompleteEvent ev);
    public abstract void retrieveComplete(POCompleteEvent ev);
    public abstract void SPCComplete(POCompleteEvent ev);
    public abstract void cancelComplete(POCompleteEvent ev);
}
