import java.sql.*;
import java.util.*;
import JProjects.eab.data.*;
import java.io.Serializable;


class Sample extends PersistentObject {

  private static DatastoreJDBC iSampleDatastore;
  private SampleDataId theDataId;
  private static String _qualifier ="";
  /* Sample Attributes and methods
  */
  // This attribute is mapped to float_val.
  private Float ifloatVal;
  // This attribute is mapped to char_val.
  private String icharVal;
  // This attribute is mapped to date_val.
  private java.sql.Date idateVal;
  static DASQLGenerator generator = new DASQLGenerator(    "sample",
    new String[] {"int_val"    },
    new String[] {"float_val"
    , "char_val"    , "date_val"    },    new String[] {"int_val"    });

    boolean modified[] = { false  , false  , false  };

  //----------------------------------------------------------------
  // Construcors.
  //----------------------------------------------------------------
  public Sample() {
    this(null,null);
  }
  public Sample(DatastoreJDBC aDatastore) {
    this(null,aDatastore);
  }
  public Sample(SampleDataId aDataId) {
    this(aDataId,null);
  }
  public Sample(SampleDataId aDataId, DatastoreJDBC aDatastore) {
    super(aDatastore);
    if ( aDataId == null ) theDataId = new SampleDataId();
    else theDataId = aDataId;
  }
  public void _executeAction( String _methodName, Object[] _params ) throws Exception {
    if ( _methodName.equals("retrieve()") ) {
      retrieve();
    }
    else if ( _methodName.equals("add()") ) {
      add();
    }
    else if ( _methodName.equals("delete()") ) {
      delete();
    }
    else if ( _methodName.equals("update(dataId)") ) {
      update( (SampleDataId)_params[0] );
    }
    else if ( _methodName.equals("update()") ) {
      update();
    }
  }
  public static String getQualifier() { return _qualifier; }
  protected POCompleteSupport _getPOCompleteSupport() { return _poSupport; }
  protected static DatastoreJDBC _getStaticDatastore() {
    if (iSampleDatastore != null) return iSampleDatastore;
    else return DatastoreJDBC.getApplicationDatastore();
  }
  void _setIntVal(int aIntVal) { theDataId._setIntVal(aIntVal); }
  void _setFloatVal(Float aFloatVal) {
    ifloatVal = aFloatVal;
  }
  void _setCharVal(String aCharVal) {
    icharVal = aCharVal;
  }
  void _setDateVal(java.sql.Date aDateVal) {
    idateVal = aDateVal;
  }
  //----------------------------------------------------------------
  // clone - returns a copy of the object.
  //----------------------------------------------------------------
  public Object clone() {
    Sample obj = new Sample((SampleDataId)theDataId.clone(),getObjectsDatastore());
    obj.ifloatVal = ifloatVal;
    obj.icharVal = icharVal;
    obj.idateVal = idateVal;
    return obj;
  }
//----------------------------------------------------------------
// equals - compares itself with another object.
//----------------------------------------------------------------
  public boolean equals(Object anObject) {
    if ( !(anObject instanceof Sample) ) return false;
  Sample aSample = (Sample)anObject;
    if ( !theDataId.equals(aSample.theDataId) ) return false;
    if (ifloatVal != aSample.ifloatVal ) {
      if ( ifloatVal == null || aSample.ifloatVal == null ) return false;
      else if ( !ifloatVal.equals( aSample.ifloatVal ) ) return false;
    }
    if (icharVal != aSample.icharVal ) {
      if ( icharVal == null || aSample.icharVal == null ) return false;
      else if ( !icharVal.equals( aSample.icharVal ) ) return false;
    }
    if (idateVal != aSample.idateVal ) {
      if ( idateVal == null || aSample.idateVal == null ) return false;
      else if ( !idateVal.equals( aSample.idateVal ) ) return false;
    }
    return true;
  }
  public Object[] getAttributes() {
    Object[] o = {  new Integer(getIntVal())
    ,getFloatVal()
    ,getCharVal()
    ,getDateVal()
    };
    return (o);
  }
  public String[] getAttributeStrings() {
    String[] s = { String.valueOf(getIntVal())
    ,String.valueOf(getFloatVal())
    ,getCharVal()
    ,String.valueOf(getDateVal())
    };
    return (s);
  }
  //----------------------------------------------------------------
  // Display methods
  //----------------------------------------------------------------
  public String toString(String aSeparator) {
    return ( String.valueOf(getIntVal())
    +aSeparator + String.valueOf(getFloatVal())
    +aSeparator + getCharVal()
    +aSeparator + String.valueOf(getDateVal())
    );
  }
  public DatastoreJDBC getCurrentDatastore() {
    if (getObjectsDatastore() != null) return getObjectsDatastore();
    else if (getDefaultDatastore() != null) return getDefaultDatastore();
    else return DatastoreJDBC.getApplicationDatastore();
  }
  //----------------------------------------------------------------
  // Default Datastore.
  //----------------------------------------------------------------
  public static DatastoreJDBC getDefaultDatastore() { return iSampleDatastore; }
  public int getIntVal() { return theDataId.getIntVal(); }
  public Float getFloatVal() { return ifloatVal; }
  public String getCharVal() { return icharVal; }
  public java.sql.Date getDateVal() { return idateVal; }
  public boolean isIntValNullable() { return false; }
  public boolean isFloatValNullable() { return true; }
  public boolean isCharValNullable() { return true; }
  public boolean isDateValNullable() { return true; }
  public void setIntVal(int aIntVal) {
    theDataId.setIntVal(aIntVal);
  }
  public void setFloatVal(Float aFloatVal) {
    modified[0] = true;
    ifloatVal = aFloatVal;
    setModified(true);
  }
  public void setCharVal(String aCharVal) {
    modified[1] = true;
    icharVal = aCharVal;
    setModified(true);
  }
  public void setDateVal(java.sql.Date aDateVal) {
    modified[2] = true;
    idateVal = aDateVal;
    setModified(true);
  }
  //----------------------------------------------------------------
  // SampleDataId.
  //----------------------------------------------------------------
  public SampleDataId getDataId() { return theDataId; }
  public PODataId getObjectDataId() { return theDataId; }
  public boolean hasDataId() { return true; }
  public void setObjectDataId(PODataId aDataId) throws DAException {
  setDataId((SampleDataId)aDataId);
  }
  public void setDataId(SampleDataId aDataId) throws DAException {
    if (aDataId == null) throw new DAException(DAResource.CANT_SET_DATAID_NULL);
    theDataId = aDataId;
    setModified(true);
    for(int i=0; i < theDataId.modified.length; i++) theDataId.modified[i] = true;
  }
  public boolean isReadOnly() { return false;}
//----------------------------------------------------------------
// Retrieve a row from the database.
//----------------------------------------------------------------
  public void retrieve() throws DAException {
    if ( !_onBackground() && isAsynchronous() ) {
      Object[] params = {   };
      _putOnBackgroundThread( "retrieve()", params );
      return ;
    }
  try {
    if (getCurrentDatastore() == null) throw new DAException(DAResource.NO_CONNECT_EXIST);
    _stmt = getCurrentDatastore().getConnection().prepareStatement(
    SampleManager.getSQLBaseQuery()
    +" where t1.int_val = ?"    );
    // put parameters
    int index=1;
  _stmt.setInt(index++,getIntVal());
    ResultSet rs = _stmt.executeQuery();
    if (!rs.next()) throw new DAException(DAResource.METHOD_NO_RESULTS);
    // get output from result set
    _setIntVal(rs.getInt(1));
    _setFloatVal(new Float(rs.getFloat(2)));
    if (rs.wasNull()) _setFloatVal(null);
    _setCharVal(rs.getString(3));
    if (rs.wasNull()) _setCharVal(null);
    _setDateVal(rs.getDate(4));
    _stmt.close(); _stmt = null;
    }
    catch(SQLException exc) {
      throw new DAException (DAResource.ERROR_IN_METHOD,"retrieve()", exc);
    }
    finally {
      _setBusy(false);
    }
    setModified(false);
    _poSupport.fireRetrieveComplete("retrieve()", null);
  }
//----------------------------------------------------------------
// Add a row to the database.
//----------------------------------------------------------------
  public void add() throws DAException {
    if ( !_onBackground() && isAsynchronous() ) {
      Object[] params = {   };
      _putOnBackgroundThread( "add()", params );
      return ;
    }
    try {
      if (getCurrentDatastore() == null) throw new DAException(DAResource.NO_CONNECT_EXIST);
      _stmt = getCurrentDatastore().getConnection().prepareStatement(
      generator.genInsert(_qualifier));
      //put parameters into statement
      int index=1;
    _stmt.setInt(index++,getIntVal());
      if (getFloatVal() == null) _stmt.setNull(index++,Types.FLOAT);
      else _stmt.setFloat(index++,getFloatVal().floatValue());
      if (getCharVal() == null) _stmt.setNull(index++,Types.CHAR);
      else _stmt.setString(index++,getCharVal());
      if (getDateVal() == null) _stmt.setNull(index++,Types.DATE);
      else _stmt.setDate(index++,getDateVal());
      int rowsAffected = _stmt.executeUpdate();
      if (rowsAffected == 0) throw new DAException(DAResource.METHOD_AFFCTD_NOROWS);
      if (rowsAffected > 1) throw new DAException(DAResource.METHOD_AFFCTD_MULTROWS);
      _stmt.close(); _stmt = null;
      }
    catch(SQLException exc) {
    throw new DAException (DAResource.ERROR_IN_METHOD,"add() ", exc);
    }
    finally {
      _setBusy(false);
    }
    setModified(false);
    _poSupport.fireUpdateComplete("add()", null);
  }
//----------------------------------------------------------------
// Delete a row from the database.
//----------------------------------------------------------------
  public void delete() throws DAException {
    if ( !_onBackground() && isAsynchronous() ) {
      Object[] params = {   };
      _putOnBackgroundThread( "delete()", params );
      return ;
    }
    try {
      if (getCurrentDatastore() == null) throw new DAException(DAResource.NO_CONNECT_EXIST);
      _stmt = getCurrentDatastore().getConnection().prepareStatement(
      generator.genDelete(_qualifier));
      //put parameters into statement
      int index=1;
    _stmt.setInt(index++,getIntVal());
      int rowsAffected = _stmt.executeUpdate();
      if (rowsAffected == 0) throw new DAException(DAResource.METHOD_AFFCTD_NOROWS);
      if (rowsAffected > 1) throw new DAException(DAResource.METHOD_AFFCTD_MULTROWS);
      _stmt.close(); _stmt = null;
      }
    catch(SQLException exc) {
    throw new DAException (DAResource.ERROR_IN_METHOD,"delete()", exc);
    }
    finally {
      _setBusy(false);
    }
    setModified(false);
    _poSupport.fireUpdateComplete("delete()", null);
  }
//----------------------------------------------------------------
// Update a row in the database. PK remains the same.
//----------------------------------------------------------------
  public void update() throws DAException {
    if ( !_onBackground() && isAsynchronous() ) {
      Object[] params = {   };
      _putOnBackgroundThread( "update()", params );
      return ;
    }
    try {
      if (getCurrentDatastore() == null) throw new DAException(DAResource.NO_CONNECT_EXIST);
      if (!isModified()) throw new DAException(DAResource.NO_CHANGES_MADE);
      if (theDataId.isModified()) setAllModified();
      _stmt = getCurrentDatastore().getConnection().prepareStatement(
        generator.genUpdate(getQualifier(), modified)
      );
      int index=1;
      if (modified[0]) {
        if (getFloatVal() == null) _stmt.setNull(index++,Types.FLOAT);
        else _stmt.setFloat(index++,getFloatVal().floatValue());
    }
      if (modified[1]) {
        if (getCharVal() == null) _stmt.setNull(index++,Types.CHAR);
        else _stmt.setString(index++,getCharVal());
    }
      if (modified[2]) {
        if (getDateVal() == null) _stmt.setNull(index++,Types.DATE);
        else _stmt.setDate(index++,getDateVal());
    }
    _stmt.setInt(index++,getIntVal());
      int rowsAffected = _stmt.executeUpdate();
      if (rowsAffected == 0) throw new DAException(DAResource.METHOD_AFFCTD_NOROWS);
      if (rowsAffected > 1) throw new DAException(DAResource.METHOD_AFFCTD_MULTROWS);
      _stmt.close(); _stmt = null;
      }
    catch(SQLException exc) {
    throw new DAException (DAResource.ERROR_IN_METHOD,"update()", exc);
    }
    finally {
      _setBusy(false);
    }
    setModified(false);
    _poSupport.fireUpdateComplete("update()", null);
  }
//----------------------------------------------------------------
// Update a row in the database. PK changes.
//----------------------------------------------------------------
  public void update(SampleDataId aDataId) throws DAException {
    if ( !_onBackground() && isAsynchronous() ) {
      Object[] params = {aDataId};
      _putOnBackgroundThread( "update(dataId)", params );
      return ;
    }
    try {
      if (getCurrentDatastore() == null) throw new DAException(DAResource.NO_CONNECT_EXIST);
      if (aDataId == null) throw new DAException(DAResource.CANT_SET_DATAID_NULL);
      if (theDataId.isModified()) setAllModified();
      _stmt = getCurrentDatastore().getConnection().prepareStatement(
        generator.genUpdateDataId(getQualifier(), modified)
        );
      int index=1;
    _stmt.setInt(index++,aDataId.getIntVal());
      if (modified[0]) {
        if (getFloatVal() == null) _stmt.setNull(index++,Types.FLOAT);
        else _stmt.setFloat(index++,getFloatVal().floatValue());
      }
      if (modified[1]) {
        if (getCharVal() == null) _stmt.setNull(index++,Types.CHAR);
        else _stmt.setString(index++,getCharVal());
      }
      if (modified[2]) {
        if (getDateVal() == null) _stmt.setNull(index++,Types.DATE);
        else _stmt.setDate(index++,getDateVal());
      }
    _stmt.setInt(index++,getIntVal());
      int rowsAffected = _stmt.executeUpdate();
      if (rowsAffected == 0) throw new DAException(DAResource.METHOD_AFFCTD_NOROWS);
      if (rowsAffected > 1) throw new DAException(DAResource.METHOD_AFFCTD_MULTROWS);
      _stmt.close(); _stmt = null;
    setDataId(aDataId);
    }
    catch(SQLException exc) {
    throw new DAException (DAResource.ERROR_IN_METHOD,"update(dataId)", exc);
    }
    finally {
      _setBusy(false);
    }
    setModified(false);
    _poSupport.fireUpdateComplete("update(dataId)", null);
  }
  void setAllModified() {
    for(int i=0; i < modified.length; i++) modified[i] = true;
  }
  public void setModified(boolean enable) {
    if ( !enable ) {
      theDataId.setModified(false);
      for(int i=0; i < modified.length; i++) modified[i] = false;
    }
    super.setModified(enable);
  }
  public boolean isModified() {
    return super.isModified() || theDataId.isModified();
  }

}
