import java.sql.*;
import java.util.*;
import JProjects.eab.data.*;
import java.io.Serializable;


class SampleJoin extends PersistentObject {

  private static DatastoreJDBC iSampleJoinDatastore;
  private SampleJoinDataId theDataId;
  private static String _qualifier ="";
  /* SampleJoin Attributes and methods
  */
  // This attribute is mapped to val.
  private String icharVal;
  // This attribute is mapped to date_val.
  private java.sql.Date idateVal;

    boolean modified[] = { false  , false  };

  //----------------------------------------------------------------
  // Construcors.
  //----------------------------------------------------------------
  public SampleJoin() {
    this(null,null);
  }
  public SampleJoin(DatastoreJDBC aDatastore) {
    this(null,aDatastore);
  }
  public SampleJoin(SampleJoinDataId aDataId) {
    this(aDataId,null);
  }
  public SampleJoin(SampleJoinDataId aDataId, DatastoreJDBC aDatastore) {
    super(aDatastore);
    if ( aDataId == null ) theDataId = new SampleJoinDataId();
    else theDataId = aDataId;
  }
  public void _executeAction( String _methodName, Object[] _params ) throws Exception {
    if ( _methodName.equals("retrieve()") ) {
      retrieve();
    }
  }
  public static String getQualifier() { return _qualifier; }
  protected POCompleteSupport _getPOCompleteSupport() { return _poSupport; }
  protected static DatastoreJDBC _getStaticDatastore() {
    if (iSampleJoinDatastore != null) return iSampleJoinDatastore;
    else return DatastoreJDBC.getApplicationDatastore();
  }
  void _setKey1(int aKey1) { theDataId._setKey1(aKey1); }
  void _setKey2(int aKey2) { theDataId._setKey2(aKey2); }
  void _setCharVal(String aCharVal) {
    icharVal = aCharVal;
  }
  void _setDateVal(java.sql.Date aDateVal) {
    idateVal = aDateVal;
  }
  //----------------------------------------------------------------
  // clone - returns a copy of the object.
  //----------------------------------------------------------------
  public Object clone() {
    SampleJoin obj = new SampleJoin((SampleJoinDataId)theDataId.clone(),getObjectsDatastore());
    obj.icharVal = icharVal;
    obj.idateVal = idateVal;
    return obj;
  }
//----------------------------------------------------------------
// equals - compares itself with another object.
//----------------------------------------------------------------
  public boolean equals(Object anObject) {
    if ( !(anObject instanceof SampleJoin) ) return false;
  SampleJoin aSampleJoin = (SampleJoin)anObject;
    if ( !theDataId.equals(aSampleJoin.theDataId) ) return false;
    if (icharVal != aSampleJoin.icharVal ) {
      if ( icharVal == null || aSampleJoin.icharVal == null ) return false;
      else if ( !icharVal.equals( aSampleJoin.icharVal ) ) return false;
    }
    if (idateVal != aSampleJoin.idateVal ) {
      if ( idateVal == null || aSampleJoin.idateVal == null ) return false;
      else if ( !idateVal.equals( aSampleJoin.idateVal ) ) return false;
    }
    return true;
  }
  public Object[] getAttributes() {
    Object[] o = {  new Integer(getKey1())
    , new Integer(getKey2())
    ,getCharVal()
    ,getDateVal()
    };
    return (o);
  }
  public String[] getAttributeStrings() {
    String[] s = { String.valueOf(getKey1())
    ,String.valueOf(getKey2())
    ,getCharVal()
    ,String.valueOf(getDateVal())
    };
    return (s);
  }
  //----------------------------------------------------------------
  // Display methods
  //----------------------------------------------------------------
  public String toString(String aSeparator) {
    return ( String.valueOf(getKey1())
    +aSeparator + String.valueOf(getKey2())
    +aSeparator + getCharVal()
    +aSeparator + String.valueOf(getDateVal())
    );
  }
  public DatastoreJDBC getCurrentDatastore() {
    if (getObjectsDatastore() != null) return getObjectsDatastore();
    else if (getDefaultDatastore() != null) return getDefaultDatastore();
    else return DatastoreJDBC.getApplicationDatastore();
  }
  //----------------------------------------------------------------
  // Default Datastore.
  //----------------------------------------------------------------
  public static DatastoreJDBC getDefaultDatastore() { return iSampleJoinDatastore; }
  public int getKey1() { return theDataId.getKey1(); }
  public int getKey2() { return theDataId.getKey2(); }
  public String getCharVal() { return icharVal; }
  public java.sql.Date getDateVal() { return idateVal; }
  public boolean isKey1Nullable() { return false; }
  public boolean isKey2Nullable() { return false; }
  public boolean isCharValNullable() { return true; }
  public boolean isDateValNullable() { return true; }
  public void setKey1(int aKey1) {
    theDataId.setKey1(aKey1);
  }
  public void setKey2(int aKey2) {
    theDataId.setKey2(aKey2);
  }
  public void setCharVal(String aCharVal) {
    modified[0] = true;
    icharVal = aCharVal;
    setModified(true);
  }
  public void setDateVal(java.sql.Date aDateVal) {
    modified[1] = true;
    idateVal = aDateVal;
    setModified(true);
  }
  //----------------------------------------------------------------
  // SampleJoinDataId.
  //----------------------------------------------------------------
  public SampleJoinDataId getDataId() { return theDataId; }
  public PODataId getObjectDataId() { return theDataId; }
  public boolean hasDataId() { return true; }
  public void setObjectDataId(PODataId aDataId) throws DAException {
  setDataId((SampleJoinDataId)aDataId);
  }
  public void setDataId(SampleJoinDataId aDataId) throws DAException {
    if (aDataId == null) throw new DAException(DAResource.CANT_SET_DATAID_NULL);
    theDataId = aDataId;
    setModified(true);
    for(int i=0; i < theDataId.modified.length; i++) theDataId.modified[i] = true;
  }
  public boolean isReadOnly() { return true;}
//----------------------------------------------------------------
// Retrieve a row from the database.
//----------------------------------------------------------------
  public void retrieve() throws DAException {
    if ( !_onBackground() && isAsynchronous() ) {
      Object[] params = {   };
      _putOnBackgroundThread( "retrieve()", params );
      return ;
    }
  try {
    if (getCurrentDatastore() == null) throw new DAException(DAResource.NO_CONNECT_EXIST);
    _stmt = getCurrentDatastore().getConnection().prepareStatement(
    SampleJoinManager.getSQLBaseQuery()
    +" and t1.key1 = ?"    +" and key2 = ?"    );
    // put parameters
    int index=1;
  _stmt.setInt(index++,getKey1());
  _stmt.setInt(index++,getKey2());
    ResultSet rs = _stmt.executeQuery();
    if (!rs.next()) throw new DAException(DAResource.METHOD_NO_RESULTS);
    // get output from result set
    _setKey1(rs.getInt(1));
    _setKey2(rs.getInt(2));
    _setCharVal(rs.getString(3));
    if (rs.wasNull()) _setCharVal(null);
    _setDateVal(rs.getDate(4));
    _stmt.close(); _stmt = null;
    }
    catch(SQLException exc) {
      throw new DAException (DAResource.ERROR_IN_METHOD,"retrieve()", exc);
    }
    finally {
      _setBusy(false);
    }
    setModified(false);
    _poSupport.fireRetrieveComplete("retrieve()", null);
  }
  void setAllModified() {
    for(int i=0; i < modified.length; i++) modified[i] = true;
  }
  public void setModified(boolean enable) {
    if ( !enable ) {
      theDataId.setModified(false);
      for(int i=0; i < modified.length; i++) modified[i] = false;
    }
    super.setModified(enable);
  }
  public boolean isModified() {
    return super.isModified() || theDataId.isModified();
  }

}
